//
//  UIApplication+Customized.h
//  DingDCommunity
//
//  Created by JianjiYuan on 14-5-1.
//  Copyright (c) 2014年 JianjiYuan. All rights reserved.
//

#import <UIKit/UIKit.h>

typedef enum : NSUInteger {
    String,
    Number,
    Array,
    Dictionary,
} ObjectType;

@interface UIApplication (Customized)

//userdefaut
+ (void)saveObject:(id)object type:(ObjectType)type key:(NSString *)key;
+ (id)getObjectType:(ObjectType)type key:(NSString *)key;

//show alert
+ (void)showAlertViewWithTitle:(NSString *)title message:(NSString *)message delegate:(id)delegate tag:(NSInteger)tag cancelButtonTitle:(NSString *)cancelButtonTitle otherButtonTitles:(NSString *)otherButtonTitles, ... NS_REQUIRES_NIL_TERMINATION;

//show loading
+ (void)showLoadingView:(NSString *)message;
+ (void)hideLoadingView;

//make toast
+ (void)showToastViewMessage:(NSString *)message;

//show noResult
+ (void)showNoResultView:(UIView *)superView desc:(NSString *)desc;
+ (void)hideNoResultView:(UIView *)superView;

//show noResult ImageView
+ (UIImageView *)showNoResultImageView:(UIView *)superView imageName:(NSString *)imageName;
+ (void)hideNoResultImageView:(UIView *)superView;


+ (void)downloadFileURL:(NSString *)aUrl fileName:(NSString *)aFileName;
+(BOOL)deleteFileByFileName:(NSString*)fileName;
@end
